package dev.shadowsoffire.apotheosis.ench.table;

package .var.folders._j.vfbv187d0bb8b8w5spzgg8180000gn.T;

import dev.shadowsoffire.apotheosis.ench.table.ApothEnchantScreen;
import dev.shadowsoffire.apotheosis.ench.table.ClueMessage;
import dev.shadowsoffire.placebo.network.MessageHelper;
import dev.shadowsoffire.placebo.network.MessageProvider;
import java.util.ArrayList;
import java.util.List;
import java.util.Optional;
import java.util.function.Supplier;
import net.minecraft.client.Minecraft;
import net.minecraft.client.gui.screens.Screen;
import net.minecraft.core.registries.BuiltInRegistries;
import net.minecraft.network.FriendlyByteBuf;
import net.minecraft.world.item.enchantment.Enchantment;
import net.minecraft.world.item.enchantment.EnchantmentInstance;
import net.minecraftforge.network.NetworkDirection;
import net.minecraftforge.network.NetworkEvent;

public class Provider implements MessageProvider<ClueMessage> {
  public Class<?> getMsgClass() {
    return ClueMessage.class;
  }
  
  public void write(ClueMessage msg, FriendlyByteBuf buf) {
    buf.writeByte(msg.clues.size());
    for (EnchantmentInstance e : msg.clues) {
      buf.writeShort(BuiltInRegistries.f_256876_.m_7447_(e.f_44947_));
      buf.writeByte(e.f_44948_);
    } 
    buf.writeByte(msg.slot);
    buf.writeBoolean(msg.all);
  }
  
  public ClueMessage read(FriendlyByteBuf buf) {
    int size = buf.readByte();
    List<EnchantmentInstance> clues = new ArrayList<>(size);
    for (int i = 0; i < size; i++) {
      Enchantment ench = (Enchantment)BuiltInRegistries.f_256876_.m_200957_(buf.readShort());
      clues.add(new EnchantmentInstance(ench, buf.readByte()));
    } 
    return new ClueMessage(buf.readByte(), clues, buf.readBoolean());
  }
  
  public void handle(ClueMessage msg, Supplier<NetworkEvent.Context> ctx) {
    MessageHelper.handlePacket(() -> {
          Screen patt2505$temp = (Minecraft.m_91087_()).f_91080_;
          if (patt2505$temp instanceof ApothEnchantScreen) {
            ApothEnchantScreen es = (ApothEnchantScreen)patt2505$temp;
            es.acceptClues(msg.slot, msg.clues, msg.all);
          } 
        }ctx);
  }
  
  public Optional<NetworkDirection> getNetworkDirection() {
    return Optional.of(NetworkDirection.PLAY_TO_CLIENT);
  }
}
